type list = Nil | Cons of int * list

let rec takeWhile l =
  match l with
  | Nil -> Nil
  | Cons(x, xs) ->
    if x>=0 then Cons(x, takeWhile xs)
    else Nil

let rec dropWhile l =
  match l with
  | Nil -> Nil
  | Cons(x, xs) ->
    if x>=0 then dropWhile xs
    else Cons(x, xs)

let rec append l ys =
  match l with
  | Nil -> ys
  | Cons(x, xs) ->
    Cons(x, append xs ys)

let main xs =
  assert(append (takeWhile xs) (dropWhile xs) = xs)

[@@@types
"takeWhile :: (t2: list) -> {t3: list | takeWhile[0:2](t2, t3)}
 dropWhile :: (t2: list) -> {t3: list | dropWhile[0:2](t2, t3)}
 main :: (xs:list) -> unit"]
