type list = Nil | Cons of int * list
type int_option = None | Some of int
type exc = Not_found

let rec find l ok exc =
  match l with
  | Nil -> exc Not_found
  | Cons(x,l) -> if x>0 then ok x else find l ok exc

let rec find_opt l =
  match l with
  | Nil -> None
  | Cons(x,l) -> if x>0 then Some x else find_opt l

let kok l x = assert (find_opt l = Some x)
let kex l Not_found = assert (find_opt l = None)
let main l = find l (kok l) (kex l)

[@@@types
"find :: (l: list) ->
         (ok: {x: int | find_ok(l, x)} -> unit) ->
         (exc: {e: exc | find_ex(l, e)} -> unit) -> unit
 find_opt :: (l: list) ->
             {r: int_option | find_opt[0:2](l, r)}
 kok :: 
        (l: {l: list | kok[0:1](l)}) ->
        (x: {x: int | kok[0:2](l, x)}) ->
        {r: unit | kok[0:3](l, x, r)}
 kex :: 
        (l: {l: list | kex[0:1](l)}) ->
        (e: {e: exc | kex[0:2](l, e)}) ->
        {r: unit | kex[0:3](l, e, r)}
 main :: (l: list) -> unit"]
