type list = Nil | Cons of int * list

let rec sum_list l =
  match l with
  | Nil -> 0
  | Cons(x, xs) -> x + sum_list xs

let rec fold_left s l =
  match l with
  | Nil -> s
  | Cons(x, xs) ->
     fold_left (s + x) xs


let main l =
  let s1 = sum_list l in
  let s2 = fold_left 0 l in
  assert(s1 = s2)

[@@@types
"fold_left :: 
              (x: int) -> (y: list) ->
              {z: int | fold_left[0:0](x, y, z)}"]
