type list = Nil | Cons of int * list

let rec sum_list l =
  match l with
  | Nil -> 0
  | Cons(x, xs) -> x + sum_list xs

let rec fold_right l s =
  match l with
  | Nil -> s
  | Cons(x, xs) ->
     x + (fold_right xs s)


let main l =
  let s1 = sum_list l in
  let s2 = fold_right l 0 in
  assert(s1 = s2)

[@@@types
"fold_right :: 
               (x: list) -> (y: int) ->
               {z: int | fold_right[0:0](x, y, z)}"]
